



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>利用PreparedStatement预防SQL注入</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">利用PreparedStatement预防SQL注入</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 18:32:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>1、什么是sql注入</h1>
<p>　　SQL 注入是用户利用某些系统没有对输入数据进行充分的检查，从而进行恶意破坏的行为。　　</p>
<p>　　例如登录用户名采用&nbsp;&nbsp;' or 1=1 or username=&lsquo;，后台数据查询语句就变成</p>
<p>　　sql = select * from users where username='' or 1=1 or username='' and password='"+password+"'"，由于sql中and的优先级比or高，所以整条查询语句等价于：</p>
<p>　　sql = select * from users where true;这样就造成随意登录</p>
<h1>2、预防sql注入</h1>
<h1>PreperedStatement是Statement的孩子，它的实例对象可以通过调用Connection.preparedStatement()方法获得，相对于Statement对象而言：PreperedStatement可以避免SQL注入的问题。Statement会使数据库频繁编译SQL，可能造成数据库缓冲区溢PreparedStatement 可对SQL进行预编译，从而提高数据库的执行效率。并且PreperedStatement对于sql中的参数，允许使用占位符的形式进行替换，简化sql语句的编写。</h1>
<div>
<pre class="prettyprint linenums"> public void add(User user) {<br />
         Connection conn = null;<br />
         PreparedStatement st = null;<br />
         ResultSet rs = null;<br />
         try{<br />
             conn = JdbcUtils.getConnection();<br />
 7             String sql = "insert into users(id,username,password,email,birthday,nickname) values(?,?,?,?,?,?)";//利用占位符<br />
 8             st = conn.prepareStatement(sql);<br />
             st.setString(1, user.getId());<br />
             st.setString(2, user.getUsername());<br />
             st.setString(3, user.getPassword());<br />
             st.setString(4, user.getEmail());<br />
             st.setDate(5, new java.sql.Date(user.getBirthday().getTime()));<br />
             st.setString(6, user.getNickname());<br />
             int num = st.executeUpdate();<br />
             if(num&lt;1){<br />
                 throw new RuntimeException(&rdquo;用户不存在");<br />
             }<br />
         }catch (Exception e) {<br />
             throw new DaoException(e);<br />
         }finally{<br />
             JdbcUtils.release(conn, st, rs);<br />
         }

     }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1kjr29.html">Spring用代码来读取properties文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1l4048.html">JavaScript变量作用域</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx6zmdq.html">MVC3&sol;4伪静态 jexus mvc伪静态</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ky6mr9.html">jsp笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1pj139.html">android中正确导入第三方jar包</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok5n7l9.html">java 验证码图片处理类，为验证码识别做准备</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmx4j09.html">jquery控制左右箭头滚动图片列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvgmnyq.html">关于SQL Server数据表的五中约束</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmzyg69.html">68篇Hadoop博客</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k133w39.html">Python&plus;django开发环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoo5g3q.html">shell文字过滤程序（十一）：paste命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgykmr8.html">Django performance</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyjkvz9.html">从RGB色转为灰度色算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m4ken8.html">201521123074 《Java程序设计》第7周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zopk0xq.html">Jmeter中正则表达式提取器使用详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mxdkj8.html">RabbitMQ 队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/960plmy9.html">linux dns域名缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o7pke8.html">iview 模态框点击确定按钮不消失</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2n4vo9.html">Cookie 类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw4y1y8.html">卸载WPS后怎么WORD的图标还是WPS</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8o4eppxq.html">Java常用的异常类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnxpj7q.html">将宿主主机上的目录挂载到Docker中</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnoe3xq.html">接口测试Jmeter&plus;Fiddler组合</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4p0vg0q.html">用PSCP在Windows和Linux之间相互传输文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql143wk9.html">Segmentation fault &lpar;core dumped&rpar; 错误的一种解决场景</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpw72l9.html">小程序发微信红包后端Nodejs实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/953oomv8.html">转发： Angular装饰器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnxx6rq.html">Docker 常用命令&mdash;&mdash;容器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k4p7lq.html">Java 常见BUG 整理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k4ojoq.html">OpenStack&lpar;queens&rpar;最小化搭建记录&mdash;&mdash;控制与计算共两个节点</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
